$fn=100;
M3_hole = 3.5;
M3_nut_e = 6.3;
M4_hole = 4.5;
M5_hole = 5.5;
M6_hole = 6.5;
M4_nut_e = 7.66 + 0.3;
M5_nut_e = 8.79 + 0.3;
M6_nut_e = 11.05 + 0.3;
M8_nut_e = 14.38+1.5;

c_w = 40;
c_h = 10;
c_l1 = 10;
c_l2 = 40;
c_gap = 20;
c_spring = 30;
c_spring_shift = -5;
c_wall = 2;
 


compliance();
//translate([0, 83, 0])base();

//canon_mount();

//drill_mount();

//blade_mount();

module blade_mount(){
  bm_w = 50;
  bm_l1 = 50;
  bm_l2 = 15;
  bm_h1 = 3;
  bm_h2 = 2;
  
  difference(){
    roundedRect([bm_w, bm_l1, bm_h1], 5);
    translate([0,2.5,-0.1])
    roundedRect([bm_w-20, bm_l1-10, bm_h1+0.2], 5);

    for(i=[0:90:270])rotate([0, 0, i])
    translate([bm_w/2-5, bm_l1/2-5, bm_h1/2])
    cylinder(d1=6, d2=M3_hole, h=bm_h1+0.1, center=true);
  }


  for(i=[0:1:1])mirror([0, i, 0])
  translate([-55, -10, 0])
  difference(){
    roundedRect([bm_w, bm_l2, bm_h2], 5);

    translate([bm_w/2-5, 0, bm_h2/2])
    cylinder(d=M3_hole, h=bm_h2+0.1, center=true);
    translate([5-bm_w/2, 0, bm_h2/2])
    cylinder(d=M3_hole, h=bm_h2+0.1, center=true);
  }

}


module drill_mount(){
  screw_dis = 112.5;
  screw_shift = 15;
  screw_grid = 10;
  mm_w = 125;
  mm_l = 40;
  mm_h = 10;
  cut_w = mm_w - 25;
  cut_l = 20;
  mm_wall = 2;
  
  sm_l = 75;
  sm_h = 5;
  sm_w = 20;
  sm_shift = 20;
  
  dm_l = 80;
  dm_w = 10;
  dm_h = 5;
  
  
  // Drill mount
  translate([20, 32, 0])rotate([0, 0, 90])
  difference(){
    roundedRect([dm_w, dm_l, dm_h], 5);
    hull(){
      translate([0, 5-dm_l/2, dm_h/2])
      cylinder(d=M3_hole, h=dm_h+0.1, center=true);
      translate([0, 5-dm_l/2+30, dm_h/2])
      cylinder(d=M3_hole, h=dm_h+0.1, center=true);
    }
    translate([0, dm_l/2-5, dm_h/2]){
      cylinder(d=M3_hole, h=dm_h+0.1, center=true);
      translate([0, 0, 2])
      cylinder(d=M3_nut_e, h=dm_h, center=true, $fn=6);
    }      
    translate([0, dm_l/2-25, dm_h/2]){
      cylinder(d=M3_hole, h=dm_h+0.1, center=true);
      translate([0, 0, 2])
      cylinder(d=M3_nut_e, h=dm_h, center=true, $fn=6);
    }
  }  
  
  // Drill mount plate()
  translate([-45, 32, 0])rotate([0, 0, 90])
  difference(){
    roundedRect([dm_w, 30, 2], 5);
    translate([0, 10 , 1])
    cylinder(d=M3_hole, h=dm_h+0.1, center=true);
    translate([0, -10 , 1])
    cylinder(d=M3_hole, h=dm_h+0.1, center=true);
    
  }
  
  
  // Shifter mount
  translate([0, 15, 0])
  difference(){
    roundedRect([sm_l, sm_w, sm_h], 5);
    translate([0, 0, sm_h/2]){
      cylinder(d=M3_hole, h=sm_h+0.1, center=true);
      translate([0, 0, 2])
      cylinder(d=M3_nut_e, h=sm_h, center=true, $fn=6);
    }
    for(i=[0:1:1])mirror([i, 0, 0])
    hull(){
      translate([sm_l/2-5, 0, sm_h/2])
      cylinder(d=M3_hole, h=sm_h+0.1, center=true);
      translate([sm_l/2-5-sm_shift, 0, sm_h/2])
      cylinder(d=M3_hole, h=sm_h+0.1, center=true);
    }
  }
  
  // Microscope mount
  difference(){
    roundedRect([mm_w, mm_l, mm_h], 5);
    translate([0, mm_l/2-cut_l/2+0.1, 0])
    cube(size=[cut_w, cut_l, mm_h*2.2], center=true);
    translate([screw_dis/2, screw_shift, mm_h/2])
    cylinder(d=M4_hole, h=mm_h+0.1, center=true);
    translate([-screw_dis/2, screw_shift, mm_h/2])
    cylinder(d=M4_hole, h=mm_h+0.1, center=true);
    
    for(i=[-5:1:5]){
      translate([i*screw_grid, -(mm_l-cut_l)/2, mm_h/2]){
        cylinder(d=M3_hole, h=mm_h+0.1, center=true);
        translate([0, 0, 2])
        cylinder(d=M3_nut_e, h=mm_h, center=true, $fn=6);
      }
    }
  }

}

module canon_mount(){
  tube_d = 27.5;
  tube_wall = 3;
  tube_l = 60;
  
  cm_d = 67;
  cm_l = 30;
  cm_wall = 2;
  cm_cut = 10;
  
  translate([0, 0, cm_l/2]){
    difference(){
      union(){
        translate([cm_d/2, 0, 0])
        cube(size=[20, cm_cut+2*cm_wall, cm_l], center=true);
        // Canon mount screws
        for(i=[60:120:360])rotate([0, 0, i]){
          translate([cm_d/2, 0, 0])rotate([0, 90, 0])
          cylinder(d1=30, d2=7, h=15, center=true);
        }
        // Tube mount screws
        for(i=[60:120:360])rotate([0, 0, i]){
          translate([tube_d/2, 0, (cm_l+tube_l)/2])rotate([0, 90, 0])
          cylinder(d1=29, d2=7, h=15, center=true);
        }
        
        cylinder(d=cm_d+2*cm_wall, h=cm_l, center=true);
        translate([0, 0, (tube_l+cm_l)/2])
        cylinder(d=tube_d+2*tube_wall, h=tube_l, center=true);
      }
      translate([0, 0, -cm_wall]){
        translate([cm_d/2, 0, -2])
        cube(size=[20-2*cm_wall, cm_cut, cm_l], center=true);
        difference(){
          cylinder(d=cm_d, h=cm_l, center=true);
          difference(){
            cylinder(d=tube_d, h=cm_l+0.1, center=true);
            cylinder(d=tube_d-2, h=cm_l+0.1, center=true);
          }
        }
      }
      translate([0, 0, (tube_l+cm_l)/2+0.2])
      cylinder(d=tube_d, h=tube_l+2*cm_wall, center=true);
      // cm mount screws
      for(i=[60:120:360])rotate([0, 0, i]){
        translate([cm_d/2, 0, 0])rotate([0, 90, 0]){
          cylinder(d=M3_hole, h=20, center=true);
          translate([0, 0, -5])
          cylinder(d=M3_nut_e, h=20, center=true, $fn=6);
        }
      }
      // Tube mount screws
      for(i=[60:120:360])rotate([0, 0, i]){
        translate([tube_d/2, 0, (cm_l+tube_l)/2])rotate([0, 90, 0]){
          cylinder(d=M3_hole, h=20, center=true);
          translate([0, 0, -5])
          cylinder(d=M3_nut_e, h=20, center=true, $fn=6);
        }
    }
      
    }
  }
}

module base(){
  b_w = c_w + 10;
  b_h = 10;
  b_l = 150;
  screw_dis = 46.5;
  flap_w = 70;
  flap_l = 60;
  
  translate([0, 0, b_h/2])
  difference(){
    union(){
      cube(size=[b_l, b_w, b_h], center=true);
      translate([0, (b_w+flap_w)/2, 0])
      cube(size=[flap_l, flap_w, b_h], center=true);
    }
    
    for(j=[0:1:1])mirror([j,0,0])
    hull(){
      translate([screw_dis/2, b_w/2+flap_w-5, 0])
      cylinder(d=M3_hole, h=b_h+0.1, center=true);
      translate([screw_dis/2, b_w/2+5, 0])
      cylinder(d=M3_hole, h=b_h+0.1, center=true);
    }
    
    for(j=[0:1:1])mirror([0,j,0])
    for(i=[0:15:150]){
      translate([i-b_l/2-7.5, 5-c_w/2, 0]){
        cylinder(d=M3_hole, h=b_h+0.1, center=true);
        translate([0, 0, b_h/2])
        cylinder(d=M3_nut_e, h=b_h, center=true, $fn=6);
      }
    }
  }
}

module compliance(){
  
  m_h1 = 5;
  m_h2 = 1;
  
  
  // Probe mount
  translate([45, 0, m_h1/2]){
    difference(){
      cube(size=[c_l1, c_w, m_h1], center=true);
      for(i=[0:1:1])mirror([0,i,0]){
        translate([0, c_w/2-5, 0]){
          cylinder(d=M3_hole, h=m_h1+0.1, center=true);
        }
        translate([0, 11-c_w/2, 0]){
          cylinder(d=M3_hole, h=m_h1+0.1, center=true);
        }
      }
      translate([0, 0, 02]){
        rotate([0, 0, 30])
        cylinder(d=M3_nut_e, h=m_h1, center=true, $fn=6);
      }
    }
  }
  
  // Spacer
  translate([30, 0, m_h2/2]){
    difference(){
      cube(size=[c_l1, c_w, m_h2], center=true);
      for(i=[0:1:1])mirror([0,i,0]){
        translate([0, c_w/2-5, 0]){
          cylinder(d=M3_hole, h=m_h2+0.1, center=true);
        }
        translate([0, 11-c_w/2, 0]){
          cylinder(d=M3_hole, h=m_h2+0.1, center=true);
        }
      }
    }
  }

  // Knob
  translate([30, 40, 1]){
    difference(){
      cylinder(d=30, h=2, center=true);
      cylinder(d=M3_hole, h=4, center=true);
    }
  }

  

  translate([0, 0, c_h/2])difference(){
    union(){
      translate([(c_gap+c_l1)/2, 0, 0]){
        cube(size=[c_l1, c_w, c_h], center=true);
      }
      translate([-(c_gap+c_l2)/2, 0, 0]){
        cube(size=[c_l2, c_w, c_h], center=true);
      }
      translate([c_spring_shift, 0, 0])
      difference(){
        scale([1,2.5,1])
        cylinder(d=c_spring*1.5, h=c_h, center=true);
        scale([1,2.635,1])
        cylinder(d=c_spring*1.5-2*c_wall, h=c_h+0.1, center=true);
      }
    }
    // probe mount holes
    for(i=[0:1:1])mirror([0,i,0])
    translate([(c_gap+c_l1)/2, c_w/2-5, 0]){
      cylinder(d=M3_hole, h=c_h+0.1, center=true);
      translate([0, 0, c_h/2])
      cylinder(d=M3_nut_e, h=c_h, center=true, $fn=6);
    }
    for(i=[0:1:1])mirror([0,i,0])
    translate([(c_gap+c_l1)/2, c_w/2-11, 0])rotate([0, 270, 0]){
      cylinder(d=M3_hole, h=c_h+0.1, center=true);
      translate([0, 0, c_h/2-1])
      cylinder(d=M3_nut_e, h=c_h, center=true, $fn=6);
    }
    // Height adjustment
    translate([-(c_gap+c_l2)/2, c_w/2-5, 0]){
      cylinder(d=M3_hole, h=c_h+0.1, center=true);
//      translate([0, 0, c_h/2])
//      cylinder(d=M3_nut_e, h=c_h, center=true, $fn=6);
    }
    translate([c_l2/2-5-(c_gap+c_l2)/2, 5-c_w/2, 0]){
      cylinder(d=M3_hole, h=c_h+0.1, center=true);
//      translate([0, 0, c_h/2])
//      cylinder(d=M3_nut_e, h=c_h, center=true, $fn=6);
    }
    translate([-(c_l2/2-5)-(c_gap+c_l2)/2, 5-c_w/2, 0]){
      cylinder(d=M3_hole, h=c_h+0.1, center=true);
//      translate([0, 0, c_h/2])
//      cylinder(d=M3_nut_e, h=c_h, center=true, $fn=6);
    }

    // length adjustment
    translate([-(c_gap+c_l2)/2, 0, 0]){
      rotate([0, 90, 0]){
        cylinder(d=M3_hole, h=c_l2+c_gap*2+c_l1*2+0.1, center=true);
      }
    }    
    translate([0, 0, 0]){
      rotate([0, 90, 0]){
        cylinder(d=M3_nut_e, h=c_gap+10, center=true, $fn=6);
      }
    }    
    translate([-c_gap/2-c_l2, 0, 0]){
      rotate([0, 90, 0]){
        cylinder(d=M3_nut_e, h=6, center=true, $fn=6);
      }
    }    
  }

} 

module roundedRect(size, radius, edges=[1, 1, 1, 1], vscale=[1,1], shift=0){
  x = size[0];
  y = size[1];
  z = size[2];

  translate([0, -shift*2, 0]){
    linear_extrude(height=z, scale=[vscale[0], vscale[1]]){
      translate([0, shift*2, 0]){
        hull(){
            // place 4 circles in the corners, with the given radius
            if(edges[0]){
              translate([(-x/2)+(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
            if(edges[1]){
              translate([(x/2)-(radius), (-y/2)+(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[2]){
              translate([(-x/2)+(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }

            if(edges[3]){
              translate([(x/2)-(radius), (y/2)-(radius), 0])
              circle(r=radius);
            }
            else{
              translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
              square(size=[radius, radius], center=true);
            }
          }
       }
    }
  }
}
